// This file was autogenerated by some hot garbage in the `uniffi` crate.
// Trust me, you don't want to mess with it!
import Foundation

// Depending on the consumer's build setup, the low-level FFI code
// might be in a separate module, or it might be compiled inline into
// this module. This is a bit of light hackery to work with both.
#if canImport(MozillaRustComponents)
    import MozillaRustComponents
#endif

private extension RustBuffer {
    // Allocate a new buffer, copying the contents of a `UInt8` array.
    init(bytes: [UInt8]) {
        let rbuf = bytes.withUnsafeBufferPointer { ptr in
            RustBuffer.from(ptr)
        }
        self.init(capacity: rbuf.capacity, len: rbuf.len, data: rbuf.data)
    }

    static func from(_ ptr: UnsafeBufferPointer<UInt8>) -> RustBuffer {
        try! rustCall { ffi_fxa_client_42fd_rustbuffer_from_bytes(ForeignBytes(bufferPointer: ptr), $0) }
    }

    // Frees the buffer in place.
    // The buffer must not be used after this is called.
    func deallocate() {
        try! rustCall { ffi_fxa_client_42fd_rustbuffer_free(self, $0) }
    }
}

private extension ForeignBytes {
    init(bufferPointer: UnsafeBufferPointer<UInt8>) {
        self.init(len: Int32(bufferPointer.count), data: bufferPointer.baseAddress)
    }
}

// For every type used in the interface, we provide helper methods for conveniently
// lifting and lowering that type from C-compatible data, and for reading and writing
// values of that type in a buffer.

// Helper classes/extensions that don't change.
// Someday, this will be in a libray of its own.

private extension Data {
    init(rustBuffer: RustBuffer) {
        // TODO: This copies the buffer. Can we read directly from a
        // Rust buffer?
        self.init(bytes: rustBuffer.data!, count: Int(rustBuffer.len))
    }
}

// A helper class to read values out of a byte buffer.
private class Reader {
    let data: Data
    var offset: Data.Index

    init(data: Data) {
        self.data = data
        offset = 0
    }

    // Reads an integer at the current offset, in big-endian order, and advances
    // the offset on success. Throws if reading the integer would move the
    // offset past the end of the buffer.
    func readInt<T: FixedWidthInteger>() throws -> T {
        let range = offset ..< offset + MemoryLayout<T>.size
        guard data.count >= range.upperBound else {
            throw UniffiInternalError.bufferOverflow
        }
        if T.self == UInt8.self {
            let value = data[offset]
            offset += 1
            return value as! T
        }
        var value: T = 0
        let _ = withUnsafeMutableBytes(of: &value) { data.copyBytes(to: $0, from: range) }
        offset = range.upperBound
        return value.bigEndian
    }

    // Reads an arbitrary number of bytes, to be used to read
    // raw bytes, this is useful when lifting strings
    func readBytes(count: Int) throws -> [UInt8] {
        let range = offset ..< (offset + count)
        guard data.count >= range.upperBound else {
            throw UniffiInternalError.bufferOverflow
        }
        var value = [UInt8](repeating: 0, count: count)
        value.withUnsafeMutableBufferPointer { buffer in
            data.copyBytes(to: buffer, from: range)
        }
        offset = range.upperBound
        return value
    }

    // Reads a float at the current offset.
    @inlinable
    func readFloat() throws -> Float {
        return Float(bitPattern: try readInt())
    }

    // Reads a float at the current offset.
    @inlinable
    func readDouble() throws -> Double {
        return Double(bitPattern: try readInt())
    }

    // Indicates if the offset has reached the end of the buffer.
    @inlinable
    func hasRemaining() -> Bool {
        return offset < data.count
    }
}

// A helper class to write values into a byte buffer.
private class Writer {
    var bytes: [UInt8]
    var offset: Array<UInt8>.Index

    init() {
        bytes = []
        offset = 0
    }

    func writeBytes<S>(_ byteArr: S) where S: Sequence, S.Element == UInt8 {
        bytes.append(contentsOf: byteArr)
    }

    // Writes an integer in big-endian order.
    //
    // Warning: make sure what you are trying to write
    // is in the correct type!
    func writeInt<T: FixedWidthInteger>(_ value: T) {
        var value = value.bigEndian
        withUnsafeBytes(of: &value) { bytes.append(contentsOf: $0) }
    }

    @inlinable
    func writeFloat(_ value: Float) {
        writeInt(value.bitPattern)
    }

    @inlinable
    func writeDouble(_ value: Double) {
        writeInt(value.bitPattern)
    }
}

// Protocol for types that transfer other types across the FFI. This is
// analogous go the Rust trait of the same name.
private protocol FfiConverter {
    associatedtype FfiType
    associatedtype SwiftType

    static func lift(_ value: FfiType) throws -> SwiftType
    static func lower(_ value: SwiftType) -> FfiType
    static func read(from buf: Reader) throws -> SwiftType
    static func write(_ value: SwiftType, into buf: Writer)
}

// Types conforming to `Primitive` pass themselves directly over the FFI.
private protocol FfiConverterPrimitive: FfiConverter where FfiType == SwiftType {}

extension FfiConverterPrimitive {
    static func lift(_ value: FfiType) throws -> SwiftType {
        return value
    }

    static func lower(_ value: SwiftType) -> FfiType {
        return value
    }
}

// Types conforming to `FfiConverterRustBuffer` lift and lower into a `RustBuffer`.
// Used for complex types where it's hard to write a custom lift/lower.
private protocol FfiConverterRustBuffer: FfiConverter where FfiType == RustBuffer {}

extension FfiConverterRustBuffer {
    static func lift(_ buf: RustBuffer) throws -> SwiftType {
        let reader = Reader(data: Data(rustBuffer: buf))
        let value = try read(from: reader)
        if reader.hasRemaining() {
            throw UniffiInternalError.incompleteData
        }
        buf.deallocate()
        return value
    }

    static func lower(_ value: SwiftType) -> RustBuffer {
        let writer = Writer()
        write(value, into: writer)
        return RustBuffer(bytes: writer.bytes)
    }
}

// An error type for FFI errors. These errors occur at the UniFFI level, not
// the library level.
private enum UniffiInternalError: LocalizedError {
    case bufferOverflow
    case incompleteData
    case unexpectedOptionalTag
    case unexpectedEnumCase
    case unexpectedNullPointer
    case unexpectedRustCallStatusCode
    case unexpectedRustCallError
    case unexpectedStaleHandle
    case rustPanic(_ message: String)

    public var errorDescription: String? {
        switch self {
        case .bufferOverflow: return "Reading the requested value would read past the end of the buffer"
        case .incompleteData: return "The buffer still has data after lifting its containing value"
        case .unexpectedOptionalTag: return "Unexpected optional tag; should be 0 or 1"
        case .unexpectedEnumCase: return "Raw enum value doesn't match any cases"
        case .unexpectedNullPointer: return "Raw pointer value was null"
        case .unexpectedRustCallStatusCode: return "Unexpected RustCallStatus code"
        case .unexpectedRustCallError: return "CALL_ERROR but no errorClass specified"
        case .unexpectedStaleHandle: return "The object in the handle map has been dropped already"
        case let .rustPanic(message): return message
        }
    }
}

private let CALL_SUCCESS: Int8 = 0
private let CALL_ERROR: Int8 = 1
private let CALL_PANIC: Int8 = 2

private extension RustCallStatus {
    init() {
        self.init(
            code: CALL_SUCCESS,
            errorBuf: RustBuffer(
                capacity: 0,
                len: 0,
                data: nil
            )
        )
    }
}

private func rustCall<T>(_ callback: (UnsafeMutablePointer<RustCallStatus>) -> T) throws -> T {
    try makeRustCall(callback, errorHandler: {
        $0.deallocate()
        return UniffiInternalError.unexpectedRustCallError
    })
}

private func rustCallWithError<T, F: FfiConverter>
(_ errorFfiConverter: F.Type, _ callback: (UnsafeMutablePointer<RustCallStatus>) -> T) throws -> T
    where F.SwiftType: Error, F.FfiType == RustBuffer
{
    try makeRustCall(callback, errorHandler: { try errorFfiConverter.lift($0) })
}

private func makeRustCall<T>(_ callback: (UnsafeMutablePointer<RustCallStatus>) -> T, errorHandler: (RustBuffer) throws -> Error) throws -> T {
    var callStatus = RustCallStatus()
    let returnedVal = callback(&callStatus)
    switch callStatus.code {
    case CALL_SUCCESS:
        return returnedVal

    case CALL_ERROR:
        throw try errorHandler(callStatus.errorBuf)

    case CALL_PANIC:
        // When the rust code sees a panic, it tries to construct a RustBuffer
        // with the message.  But if that code panics, then it just sends back
        // an empty buffer.
        if callStatus.errorBuf.len > 0 {
            throw UniffiInternalError.rustPanic(try FfiConverterString.lift(callStatus.errorBuf))
        } else {
            callStatus.errorBuf.deallocate()
            throw UniffiInternalError.rustPanic("Rust panic")
        }

    default:
        throw UniffiInternalError.unexpectedRustCallStatusCode
    }
}

// Public interface members begin here.

private struct FfiConverterInt64: FfiConverterPrimitive {
    typealias FfiType = Int64
    typealias SwiftType = Int64

    static func read(from buf: Reader) throws -> Int64 {
        return try lift(buf.readInt())
    }

    static func write(_ value: Int64, into buf: Writer) {
        buf.writeInt(lower(value))
    }
}

private struct FfiConverterBool: FfiConverter {
    typealias FfiType = Int8
    typealias SwiftType = Bool

    static func lift(_ value: Int8) throws -> Bool {
        return value != 0
    }

    static func lower(_ value: Bool) -> Int8 {
        return value ? 1 : 0
    }

    static func read(from buf: Reader) throws -> Bool {
        return try lift(buf.readInt())
    }

    static func write(_ value: Bool, into buf: Writer) {
        buf.writeInt(lower(value))
    }
}

private struct FfiConverterString: FfiConverter {
    typealias SwiftType = String
    typealias FfiType = RustBuffer

    static func lift(_ value: RustBuffer) throws -> String {
        defer {
            value.deallocate()
        }
        if value.data == nil {
            return String()
        }
        let bytes = UnsafeBufferPointer<UInt8>(start: value.data!, count: Int(value.len))
        return String(bytes: bytes, encoding: String.Encoding.utf8)!
    }

    static func lower(_ value: String) -> RustBuffer {
        return value.utf8CString.withUnsafeBufferPointer { ptr in
            // The swift string gives us int8_t, we want uint8_t.
            ptr.withMemoryRebound(to: UInt8.self) { ptr in
                // The swift string gives us a trailing null byte, we don't want it.
                let buf = UnsafeBufferPointer(rebasing: ptr.prefix(upTo: ptr.count - 1))
                return RustBuffer.from(buf)
            }
        }
    }

    static func read(from buf: Reader) throws -> String {
        let len: Int32 = try buf.readInt()
        return String(bytes: try buf.readBytes(count: Int(len)), encoding: String.Encoding.utf8)!
    }

    static func write(_ value: String, into buf: Writer) {
        let len = Int32(value.utf8.count)
        buf.writeInt(len)
        buf.writeBytes(value.utf8)
    }
}

public protocol FirefoxAccountProtocol {
    func toJson() throws -> String
    func beginOauthFlow(scopes: [String], entrypoint: String, metrics: MetricsParams?) throws -> String
    func getPairingAuthorityUrl() throws -> String
    func beginPairingFlow(pairingUrl: String, scopes: [String], entrypoint: String, metrics: MetricsParams?) throws -> String
    func completeOauthFlow(code: String, state: String) throws
    func checkAuthorizationStatus() throws -> AuthorizationInfo
    func disconnect()
    func getProfile(ignoreCache: Bool) throws -> Profile
    func initializeDevice(name: String, deviceType: DeviceType, supportedCapabilities: [DeviceCapability]) throws
    func getCurrentDeviceId() throws -> String
    func getDevices(ignoreCache: Bool) throws -> [Device]
    func getAttachedClients() throws -> [AttachedClient]
    func setDeviceName(displayName: String) throws
    func clearDeviceName() throws
    func ensureCapabilities(supportedCapabilities: [DeviceCapability]) throws
    func setPushSubscription(subscription: DevicePushSubscription) throws
    func handlePushMessage(payload: String) throws -> [AccountEvent]
    func pollDeviceCommands() throws -> [IncomingDeviceCommand]
    func sendSingleTab(targetDeviceId: String, title: String, url: String) throws
    func getTokenServerEndpointUrl() throws -> String
    func getConnectionSuccessUrl() throws -> String
    func getManageAccountUrl(entrypoint: String) throws -> String
    func getManageDevicesUrl(entrypoint: String) throws -> String
    func getAccessToken(scope: String, ttl: Int64?) throws -> AccessTokenInfo
    func getSessionToken() throws -> String
    func handleSessionTokenChange(sessionToken: String) throws
    func authorizeCodeUsingSessionToken(params: AuthorizationParameters) throws -> String
    func clearAccessTokenCache()
    func gatherTelemetry() throws -> String
    func migrateFromSessionToken(sessionToken: String, kSync: String, kXcs: String, copySessionToken: Bool) throws -> FxAMigrationResult
    func retryMigrateFromSessionToken() throws -> FxAMigrationResult
    func isInMigrationState() -> MigrationState
}

public class FirefoxAccount: FirefoxAccountProtocol {
    fileprivate let pointer: UnsafeMutableRawPointer

    // TODO: We'd like this to be `private` but for Swifty reasons,
    // we can't implement `FfiConverter` without making this `required` and we can't
    // make it `required` without making it `public`.
    required init(unsafeFromRawPointer pointer: UnsafeMutableRawPointer) {
        self.pointer = pointer
    }

    public convenience init(contentUrl: String, clientId: String, redirectUri: String, tokenServerUrlOverride: String?) {
        self.init(unsafeFromRawPointer: try!

            rustCall {
                fxa_client_42fd_FirefoxAccount_new(
                    FfiConverterString.lower(contentUrl),
                    FfiConverterString.lower(clientId),
                    FfiConverterString.lower(redirectUri),
                    FfiConverterOptionString.lower(tokenServerUrlOverride), $0
                )
            })
    }

    deinit {
        try! rustCall { ffi_fxa_client_42fd_FirefoxAccount_object_free(pointer, $0) }
    }

    public static func fromJson(data: String) throws -> FirefoxAccount {
        return FirefoxAccount(unsafeFromRawPointer: try

            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_from_json(
                    FfiConverterString.lower(data), $0
                )
            })
    }

    public func toJson() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_to_json(self.pointer, $0)
                }
        )
    }

    public func beginOauthFlow(scopes: [String], entrypoint: String, metrics: MetricsParams?) throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_begin_oauth_flow(self.pointer,
                                                                    FfiConverterSequenceString.lower(scopes),
                                                                    FfiConverterString.lower(entrypoint),
                                                                    FfiConverterOptionTypeMetricsParams.lower(metrics), $0)
                }
        )
    }

    public func getPairingAuthorityUrl() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_pairing_authority_url(self.pointer, $0)
                }
        )
    }

    public func beginPairingFlow(pairingUrl: String, scopes: [String], entrypoint: String, metrics: MetricsParams?) throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_begin_pairing_flow(self.pointer,
                                                                      FfiConverterString.lower(pairingUrl),
                                                                      FfiConverterSequenceString.lower(scopes),
                                                                      FfiConverterString.lower(entrypoint),
                                                                      FfiConverterOptionTypeMetricsParams.lower(metrics), $0)
                }
        )
    }

    public func completeOauthFlow(code: String, state: String) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_complete_oauth_flow(self.pointer,
                                                                   FfiConverterString.lower(code),
                                                                   FfiConverterString.lower(state), $0)
            }
    }

    public func checkAuthorizationStatus() throws -> AuthorizationInfo {
        return try FfiConverterTypeAuthorizationInfo.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_check_authorization_status(self.pointer, $0)
                }
        )
    }

    public func disconnect() {
        try!
            rustCall {
                fxa_client_42fd_FirefoxAccount_disconnect(self.pointer, $0)
            }
    }

    public func getProfile(ignoreCache: Bool) throws -> Profile {
        return try FfiConverterTypeProfile.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_profile(self.pointer,
                                                               FfiConverterBool.lower(ignoreCache), $0)
                }
        )
    }

    public func initializeDevice(name: String, deviceType: DeviceType, supportedCapabilities: [DeviceCapability]) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_initialize_device(self.pointer,
                                                                 FfiConverterString.lower(name),
                                                                 FfiConverterTypeDeviceType.lower(deviceType),
                                                                 FfiConverterSequenceTypeDeviceCapability.lower(supportedCapabilities), $0)
            }
    }

    public func getCurrentDeviceId() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_current_device_id(self.pointer, $0)
                }
        )
    }

    public func getDevices(ignoreCache: Bool) throws -> [Device] {
        return try FfiConverterSequenceTypeDevice.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_devices(self.pointer,
                                                               FfiConverterBool.lower(ignoreCache), $0)
                }
        )
    }

    public func getAttachedClients() throws -> [AttachedClient] {
        return try FfiConverterSequenceTypeAttachedClient.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_attached_clients(self.pointer, $0)
                }
        )
    }

    public func setDeviceName(displayName: String) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_set_device_name(self.pointer,
                                                               FfiConverterString.lower(displayName), $0)
            }
    }

    public func clearDeviceName() throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_clear_device_name(self.pointer, $0)
            }
    }

    public func ensureCapabilities(supportedCapabilities: [DeviceCapability]) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_ensure_capabilities(self.pointer,
                                                                   FfiConverterSequenceTypeDeviceCapability.lower(supportedCapabilities), $0)
            }
    }

    public func setPushSubscription(subscription: DevicePushSubscription) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_set_push_subscription(self.pointer,
                                                                     FfiConverterTypeDevicePushSubscription.lower(subscription), $0)
            }
    }

    public func handlePushMessage(payload: String) throws -> [AccountEvent] {
        return try FfiConverterSequenceTypeAccountEvent.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_handle_push_message(self.pointer,
                                                                       FfiConverterString.lower(payload), $0)
                }
        )
    }

    public func pollDeviceCommands() throws -> [IncomingDeviceCommand] {
        return try FfiConverterSequenceTypeIncomingDeviceCommand.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_poll_device_commands(self.pointer, $0)
                }
        )
    }

    public func sendSingleTab(targetDeviceId: String, title: String, url: String) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_send_single_tab(self.pointer,
                                                               FfiConverterString.lower(targetDeviceId),
                                                               FfiConverterString.lower(title),
                                                               FfiConverterString.lower(url), $0)
            }
    }

    public func getTokenServerEndpointUrl() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_token_server_endpoint_url(self.pointer, $0)
                }
        )
    }

    public func getConnectionSuccessUrl() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_connection_success_url(self.pointer, $0)
                }
        )
    }

    public func getManageAccountUrl(entrypoint: String) throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_manage_account_url(self.pointer,
                                                                          FfiConverterString.lower(entrypoint), $0)
                }
        )
    }

    public func getManageDevicesUrl(entrypoint: String) throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_manage_devices_url(self.pointer,
                                                                          FfiConverterString.lower(entrypoint), $0)
                }
        )
    }

    public func getAccessToken(scope: String, ttl: Int64?) throws -> AccessTokenInfo {
        return try FfiConverterTypeAccessTokenInfo.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_access_token(self.pointer,
                                                                    FfiConverterString.lower(scope),
                                                                    FfiConverterOptionInt64.lower(ttl), $0)
                }
        )
    }

    public func getSessionToken() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_get_session_token(self.pointer, $0)
                }
        )
    }

    public func handleSessionTokenChange(sessionToken: String) throws {
        try
            rustCallWithError(FfiConverterTypeFxaError.self) {
                fxa_client_42fd_FirefoxAccount_handle_session_token_change(self.pointer,
                                                                           FfiConverterString.lower(sessionToken), $0)
            }
    }

    public func authorizeCodeUsingSessionToken(params: AuthorizationParameters) throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_authorize_code_using_session_token(self.pointer,
                                                                                      FfiConverterTypeAuthorizationParameters.lower(params), $0)
                }
        )
    }

    public func clearAccessTokenCache() {
        try!
            rustCall {
                fxa_client_42fd_FirefoxAccount_clear_access_token_cache(self.pointer, $0)
            }
    }

    public func gatherTelemetry() throws -> String {
        return try FfiConverterString.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_gather_telemetry(self.pointer, $0)
                }
        )
    }

    public func migrateFromSessionToken(sessionToken: String, kSync: String, kXcs: String, copySessionToken: Bool) throws -> FxAMigrationResult {
        return try FfiConverterTypeFxAMigrationResult.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_migrate_from_session_token(self.pointer,
                                                                              FfiConverterString.lower(sessionToken),
                                                                              FfiConverterString.lower(kSync),
                                                                              FfiConverterString.lower(kXcs),
                                                                              FfiConverterBool.lower(copySessionToken), $0)
                }
        )
    }

    public func retryMigrateFromSessionToken() throws -> FxAMigrationResult {
        return try FfiConverterTypeFxAMigrationResult.lift(
            try
                rustCallWithError(FfiConverterTypeFxaError.self) {
                    fxa_client_42fd_FirefoxAccount_retry_migrate_from_session_token(self.pointer, $0)
                }
        )
    }

    public func isInMigrationState() -> MigrationState {
        return try! FfiConverterTypeMigrationState.lift(
            try!
                rustCall {
                    fxa_client_42fd_FirefoxAccount_is_in_migration_state(self.pointer, $0)
                }
        )
    }
}

private struct FfiConverterTypeFirefoxAccount: FfiConverter {
    typealias FfiType = UnsafeMutableRawPointer
    typealias SwiftType = FirefoxAccount

    static func read(from buf: Reader) throws -> FirefoxAccount {
        let v: UInt64 = try buf.readInt()
        // The Rust code won't compile if a pointer won't fit in a UInt64.
        // We have to go via `UInt` because that's the thing that's the size of a pointer.
        let ptr = UnsafeMutableRawPointer(bitPattern: UInt(truncatingIfNeeded: v))
        if ptr == nil {
            throw UniffiInternalError.unexpectedNullPointer
        }
        return try lift(ptr!)
    }

    static func write(_ value: FirefoxAccount, into buf: Writer) {
        // This fiddling is because `Int` is the thing that's the same size as a pointer.
        // The Rust code won't compile if a pointer won't fit in a `UInt64`.
        buf.writeInt(UInt64(bitPattern: Int64(Int(bitPattern: lower(value)))))
    }

    static func lift(_ pointer: UnsafeMutableRawPointer) throws -> FirefoxAccount {
        return FirefoxAccount(unsafeFromRawPointer: pointer)
    }

    static func lower(_ value: FirefoxAccount) -> UnsafeMutableRawPointer {
        return value.pointer
    }
}

public struct AccessTokenInfo {
    public var scope: String
    public var token: String
    public var key: ScopedKey?
    public var expiresAt: Int64

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(scope: String, token: String, key: ScopedKey?, expiresAt: Int64) {
        self.scope = scope
        self.token = token
        self.key = key
        self.expiresAt = expiresAt
    }
}

extension AccessTokenInfo: Equatable, Hashable {
    public static func == (lhs: AccessTokenInfo, rhs: AccessTokenInfo) -> Bool {
        if lhs.scope != rhs.scope {
            return false
        }
        if lhs.token != rhs.token {
            return false
        }
        if lhs.key != rhs.key {
            return false
        }
        if lhs.expiresAt != rhs.expiresAt {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(scope)
        hasher.combine(token)
        hasher.combine(key)
        hasher.combine(expiresAt)
    }
}

private struct FfiConverterTypeAccessTokenInfo: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AccessTokenInfo {
        return try AccessTokenInfo(
            scope: FfiConverterString.read(from: buf),
            token: FfiConverterString.read(from: buf),
            key: FfiConverterOptionTypeScopedKey.read(from: buf),
            expiresAt: FfiConverterInt64.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AccessTokenInfo, into buf: Writer) {
        FfiConverterString.write(value.scope, into: buf)
        FfiConverterString.write(value.token, into: buf)
        FfiConverterOptionTypeScopedKey.write(value.key, into: buf)
        FfiConverterInt64.write(value.expiresAt, into: buf)
    }
}

public struct AttachedClient {
    public var clientId: String?
    public var deviceId: String?
    public var deviceType: DeviceType?
    public var isCurrentSession: Bool
    public var name: String?
    public var createdTime: Int64?
    public var lastAccessTime: Int64?
    public var scope: [String]?

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(clientId: String?, deviceId: String?, deviceType: DeviceType?, isCurrentSession: Bool, name: String?, createdTime: Int64?, lastAccessTime: Int64?, scope: [String]?) {
        self.clientId = clientId
        self.deviceId = deviceId
        self.deviceType = deviceType
        self.isCurrentSession = isCurrentSession
        self.name = name
        self.createdTime = createdTime
        self.lastAccessTime = lastAccessTime
        self.scope = scope
    }
}

extension AttachedClient: Equatable, Hashable {
    public static func == (lhs: AttachedClient, rhs: AttachedClient) -> Bool {
        if lhs.clientId != rhs.clientId {
            return false
        }
        if lhs.deviceId != rhs.deviceId {
            return false
        }
        if lhs.deviceType != rhs.deviceType {
            return false
        }
        if lhs.isCurrentSession != rhs.isCurrentSession {
            return false
        }
        if lhs.name != rhs.name {
            return false
        }
        if lhs.createdTime != rhs.createdTime {
            return false
        }
        if lhs.lastAccessTime != rhs.lastAccessTime {
            return false
        }
        if lhs.scope != rhs.scope {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(clientId)
        hasher.combine(deviceId)
        hasher.combine(deviceType)
        hasher.combine(isCurrentSession)
        hasher.combine(name)
        hasher.combine(createdTime)
        hasher.combine(lastAccessTime)
        hasher.combine(scope)
    }
}

private struct FfiConverterTypeAttachedClient: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AttachedClient {
        return try AttachedClient(
            clientId: FfiConverterOptionString.read(from: buf),
            deviceId: FfiConverterOptionString.read(from: buf),
            deviceType: FfiConverterOptionTypeDeviceType.read(from: buf),
            isCurrentSession: FfiConverterBool.read(from: buf),
            name: FfiConverterOptionString.read(from: buf),
            createdTime: FfiConverterOptionInt64.read(from: buf),
            lastAccessTime: FfiConverterOptionInt64.read(from: buf),
            scope: FfiConverterOptionSequenceString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AttachedClient, into buf: Writer) {
        FfiConverterOptionString.write(value.clientId, into: buf)
        FfiConverterOptionString.write(value.deviceId, into: buf)
        FfiConverterOptionTypeDeviceType.write(value.deviceType, into: buf)
        FfiConverterBool.write(value.isCurrentSession, into: buf)
        FfiConverterOptionString.write(value.name, into: buf)
        FfiConverterOptionInt64.write(value.createdTime, into: buf)
        FfiConverterOptionInt64.write(value.lastAccessTime, into: buf)
        FfiConverterOptionSequenceString.write(value.scope, into: buf)
    }
}

public struct AuthorizationInfo {
    public var active: Bool

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(active: Bool) {
        self.active = active
    }
}

extension AuthorizationInfo: Equatable, Hashable {
    public static func == (lhs: AuthorizationInfo, rhs: AuthorizationInfo) -> Bool {
        if lhs.active != rhs.active {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(active)
    }
}

private struct FfiConverterTypeAuthorizationInfo: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AuthorizationInfo {
        return try AuthorizationInfo(
            active: FfiConverterBool.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AuthorizationInfo, into buf: Writer) {
        FfiConverterBool.write(value.active, into: buf)
    }
}

public struct AuthorizationParameters {
    public var clientId: String
    public var scope: [String]
    public var state: String
    public var accessType: String
    public var codeChallenge: String?
    public var codeChallengeMethod: String?
    public var keysJwk: String?

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(clientId: String, scope: [String], state: String, accessType: String, codeChallenge: String?, codeChallengeMethod: String?, keysJwk: String?) {
        self.clientId = clientId
        self.scope = scope
        self.state = state
        self.accessType = accessType
        self.codeChallenge = codeChallenge
        self.codeChallengeMethod = codeChallengeMethod
        self.keysJwk = keysJwk
    }
}

extension AuthorizationParameters: Equatable, Hashable {
    public static func == (lhs: AuthorizationParameters, rhs: AuthorizationParameters) -> Bool {
        if lhs.clientId != rhs.clientId {
            return false
        }
        if lhs.scope != rhs.scope {
            return false
        }
        if lhs.state != rhs.state {
            return false
        }
        if lhs.accessType != rhs.accessType {
            return false
        }
        if lhs.codeChallenge != rhs.codeChallenge {
            return false
        }
        if lhs.codeChallengeMethod != rhs.codeChallengeMethod {
            return false
        }
        if lhs.keysJwk != rhs.keysJwk {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(clientId)
        hasher.combine(scope)
        hasher.combine(state)
        hasher.combine(accessType)
        hasher.combine(codeChallenge)
        hasher.combine(codeChallengeMethod)
        hasher.combine(keysJwk)
    }
}

private struct FfiConverterTypeAuthorizationParameters: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> AuthorizationParameters {
        return try AuthorizationParameters(
            clientId: FfiConverterString.read(from: buf),
            scope: FfiConverterSequenceString.read(from: buf),
            state: FfiConverterString.read(from: buf),
            accessType: FfiConverterString.read(from: buf),
            codeChallenge: FfiConverterOptionString.read(from: buf),
            codeChallengeMethod: FfiConverterOptionString.read(from: buf),
            keysJwk: FfiConverterOptionString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: AuthorizationParameters, into buf: Writer) {
        FfiConverterString.write(value.clientId, into: buf)
        FfiConverterSequenceString.write(value.scope, into: buf)
        FfiConverterString.write(value.state, into: buf)
        FfiConverterString.write(value.accessType, into: buf)
        FfiConverterOptionString.write(value.codeChallenge, into: buf)
        FfiConverterOptionString.write(value.codeChallengeMethod, into: buf)
        FfiConverterOptionString.write(value.keysJwk, into: buf)
    }
}

public struct Device {
    public var id: String
    public var displayName: String
    public var deviceType: DeviceType
    public var capabilities: [DeviceCapability]
    public var pushSubscription: DevicePushSubscription?
    public var pushEndpointExpired: Bool
    public var isCurrentDevice: Bool
    public var lastAccessTime: Int64?

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(id: String, displayName: String, deviceType: DeviceType, capabilities: [DeviceCapability], pushSubscription: DevicePushSubscription?, pushEndpointExpired: Bool, isCurrentDevice: Bool, lastAccessTime: Int64?) {
        self.id = id
        self.displayName = displayName
        self.deviceType = deviceType
        self.capabilities = capabilities
        self.pushSubscription = pushSubscription
        self.pushEndpointExpired = pushEndpointExpired
        self.isCurrentDevice = isCurrentDevice
        self.lastAccessTime = lastAccessTime
    }
}

extension Device: Equatable, Hashable {
    public static func == (lhs: Device, rhs: Device) -> Bool {
        if lhs.id != rhs.id {
            return false
        }
        if lhs.displayName != rhs.displayName {
            return false
        }
        if lhs.deviceType != rhs.deviceType {
            return false
        }
        if lhs.capabilities != rhs.capabilities {
            return false
        }
        if lhs.pushSubscription != rhs.pushSubscription {
            return false
        }
        if lhs.pushEndpointExpired != rhs.pushEndpointExpired {
            return false
        }
        if lhs.isCurrentDevice != rhs.isCurrentDevice {
            return false
        }
        if lhs.lastAccessTime != rhs.lastAccessTime {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(id)
        hasher.combine(displayName)
        hasher.combine(deviceType)
        hasher.combine(capabilities)
        hasher.combine(pushSubscription)
        hasher.combine(pushEndpointExpired)
        hasher.combine(isCurrentDevice)
        hasher.combine(lastAccessTime)
    }
}

private struct FfiConverterTypeDevice: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> Device {
        return try Device(
            id: FfiConverterString.read(from: buf),
            displayName: FfiConverterString.read(from: buf),
            deviceType: FfiConverterTypeDeviceType.read(from: buf),
            capabilities: FfiConverterSequenceTypeDeviceCapability.read(from: buf),
            pushSubscription: FfiConverterOptionTypeDevicePushSubscription.read(from: buf),
            pushEndpointExpired: FfiConverterBool.read(from: buf),
            isCurrentDevice: FfiConverterBool.read(from: buf),
            lastAccessTime: FfiConverterOptionInt64.read(from: buf)
        )
    }

    fileprivate static func write(_ value: Device, into buf: Writer) {
        FfiConverterString.write(value.id, into: buf)
        FfiConverterString.write(value.displayName, into: buf)
        FfiConverterTypeDeviceType.write(value.deviceType, into: buf)
        FfiConverterSequenceTypeDeviceCapability.write(value.capabilities, into: buf)
        FfiConverterOptionTypeDevicePushSubscription.write(value.pushSubscription, into: buf)
        FfiConverterBool.write(value.pushEndpointExpired, into: buf)
        FfiConverterBool.write(value.isCurrentDevice, into: buf)
        FfiConverterOptionInt64.write(value.lastAccessTime, into: buf)
    }
}

public struct DevicePushSubscription {
    public var endpoint: String
    public var publicKey: String
    public var authKey: String

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(endpoint: String, publicKey: String, authKey: String) {
        self.endpoint = endpoint
        self.publicKey = publicKey
        self.authKey = authKey
    }
}

extension DevicePushSubscription: Equatable, Hashable {
    public static func == (lhs: DevicePushSubscription, rhs: DevicePushSubscription) -> Bool {
        if lhs.endpoint != rhs.endpoint {
            return false
        }
        if lhs.publicKey != rhs.publicKey {
            return false
        }
        if lhs.authKey != rhs.authKey {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(endpoint)
        hasher.combine(publicKey)
        hasher.combine(authKey)
    }
}

private struct FfiConverterTypeDevicePushSubscription: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> DevicePushSubscription {
        return try DevicePushSubscription(
            endpoint: FfiConverterString.read(from: buf),
            publicKey: FfiConverterString.read(from: buf),
            authKey: FfiConverterString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: DevicePushSubscription, into buf: Writer) {
        FfiConverterString.write(value.endpoint, into: buf)
        FfiConverterString.write(value.publicKey, into: buf)
        FfiConverterString.write(value.authKey, into: buf)
    }
}

public struct FxAMigrationResult {
    public var totalDuration: Int64

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(totalDuration: Int64) {
        self.totalDuration = totalDuration
    }
}

extension FxAMigrationResult: Equatable, Hashable {
    public static func == (lhs: FxAMigrationResult, rhs: FxAMigrationResult) -> Bool {
        if lhs.totalDuration != rhs.totalDuration {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(totalDuration)
    }
}

private struct FfiConverterTypeFxAMigrationResult: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> FxAMigrationResult {
        return try FxAMigrationResult(
            totalDuration: FfiConverterInt64.read(from: buf)
        )
    }

    fileprivate static func write(_ value: FxAMigrationResult, into buf: Writer) {
        FfiConverterInt64.write(value.totalDuration, into: buf)
    }
}

public struct MetricsParams {
    public var parameters: [String: String]

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(parameters: [String: String]) {
        self.parameters = parameters
    }
}

extension MetricsParams: Equatable, Hashable {
    public static func == (lhs: MetricsParams, rhs: MetricsParams) -> Bool {
        if lhs.parameters != rhs.parameters {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(parameters)
    }
}

private struct FfiConverterTypeMetricsParams: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> MetricsParams {
        return try MetricsParams(
            parameters: FfiConverterDictionaryStringString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: MetricsParams, into buf: Writer) {
        FfiConverterDictionaryStringString.write(value.parameters, into: buf)
    }
}

public struct Profile {
    public var uid: String
    public var email: String
    public var displayName: String?
    public var avatar: String
    public var isDefaultAvatar: Bool

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(uid: String, email: String, displayName: String?, avatar: String, isDefaultAvatar: Bool) {
        self.uid = uid
        self.email = email
        self.displayName = displayName
        self.avatar = avatar
        self.isDefaultAvatar = isDefaultAvatar
    }
}

extension Profile: Equatable, Hashable {
    public static func == (lhs: Profile, rhs: Profile) -> Bool {
        if lhs.uid != rhs.uid {
            return false
        }
        if lhs.email != rhs.email {
            return false
        }
        if lhs.displayName != rhs.displayName {
            return false
        }
        if lhs.avatar != rhs.avatar {
            return false
        }
        if lhs.isDefaultAvatar != rhs.isDefaultAvatar {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(uid)
        hasher.combine(email)
        hasher.combine(displayName)
        hasher.combine(avatar)
        hasher.combine(isDefaultAvatar)
    }
}

private struct FfiConverterTypeProfile: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> Profile {
        return try Profile(
            uid: FfiConverterString.read(from: buf),
            email: FfiConverterString.read(from: buf),
            displayName: FfiConverterOptionString.read(from: buf),
            avatar: FfiConverterString.read(from: buf),
            isDefaultAvatar: FfiConverterBool.read(from: buf)
        )
    }

    fileprivate static func write(_ value: Profile, into buf: Writer) {
        FfiConverterString.write(value.uid, into: buf)
        FfiConverterString.write(value.email, into: buf)
        FfiConverterOptionString.write(value.displayName, into: buf)
        FfiConverterString.write(value.avatar, into: buf)
        FfiConverterBool.write(value.isDefaultAvatar, into: buf)
    }
}

public struct ScopedKey {
    public var kty: String
    public var scope: String
    public var k: String
    public var kid: String

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(kty: String, scope: String, k: String, kid: String) {
        self.kty = kty
        self.scope = scope
        self.k = k
        self.kid = kid
    }
}

extension ScopedKey: Equatable, Hashable {
    public static func == (lhs: ScopedKey, rhs: ScopedKey) -> Bool {
        if lhs.kty != rhs.kty {
            return false
        }
        if lhs.scope != rhs.scope {
            return false
        }
        if lhs.k != rhs.k {
            return false
        }
        if lhs.kid != rhs.kid {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(kty)
        hasher.combine(scope)
        hasher.combine(k)
        hasher.combine(kid)
    }
}

private struct FfiConverterTypeScopedKey: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> ScopedKey {
        return try ScopedKey(
            kty: FfiConverterString.read(from: buf),
            scope: FfiConverterString.read(from: buf),
            k: FfiConverterString.read(from: buf),
            kid: FfiConverterString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: ScopedKey, into buf: Writer) {
        FfiConverterString.write(value.kty, into: buf)
        FfiConverterString.write(value.scope, into: buf)
        FfiConverterString.write(value.k, into: buf)
        FfiConverterString.write(value.kid, into: buf)
    }
}

public struct SendTabPayload {
    public var entries: [TabHistoryEntry]
    public var flowId: String
    public var streamId: String

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(entries: [TabHistoryEntry], flowId: String, streamId: String) {
        self.entries = entries
        self.flowId = flowId
        self.streamId = streamId
    }
}

extension SendTabPayload: Equatable, Hashable {
    public static func == (lhs: SendTabPayload, rhs: SendTabPayload) -> Bool {
        if lhs.entries != rhs.entries {
            return false
        }
        if lhs.flowId != rhs.flowId {
            return false
        }
        if lhs.streamId != rhs.streamId {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(entries)
        hasher.combine(flowId)
        hasher.combine(streamId)
    }
}

private struct FfiConverterTypeSendTabPayload: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> SendTabPayload {
        return try SendTabPayload(
            entries: FfiConverterSequenceTypeTabHistoryEntry.read(from: buf),
            flowId: FfiConverterString.read(from: buf),
            streamId: FfiConverterString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: SendTabPayload, into buf: Writer) {
        FfiConverterSequenceTypeTabHistoryEntry.write(value.entries, into: buf)
        FfiConverterString.write(value.flowId, into: buf)
        FfiConverterString.write(value.streamId, into: buf)
    }
}

public struct TabHistoryEntry {
    public var title: String
    public var url: String

    // Default memberwise initializers are never public by default, so we
    // declare one manually.
    public init(title: String, url: String) {
        self.title = title
        self.url = url
    }
}

extension TabHistoryEntry: Equatable, Hashable {
    public static func == (lhs: TabHistoryEntry, rhs: TabHistoryEntry) -> Bool {
        if lhs.title != rhs.title {
            return false
        }
        if lhs.url != rhs.url {
            return false
        }
        return true
    }

    public func hash(into hasher: inout Hasher) {
        hasher.combine(title)
        hasher.combine(url)
    }
}

private struct FfiConverterTypeTabHistoryEntry: FfiConverterRustBuffer {
    fileprivate static func read(from buf: Reader) throws -> TabHistoryEntry {
        return try TabHistoryEntry(
            title: FfiConverterString.read(from: buf),
            url: FfiConverterString.read(from: buf)
        )
    }

    fileprivate static func write(_ value: TabHistoryEntry, into buf: Writer) {
        FfiConverterString.write(value.title, into: buf)
        FfiConverterString.write(value.url, into: buf)
    }
}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.
public enum AccountEvent {
    case commandReceived(command: IncomingDeviceCommand)
    case profileUpdated
    case accountAuthStateChanged
    case accountDestroyed
    case deviceConnected(deviceName: String)
    case deviceDisconnected(deviceId: String, isLocalDevice: Bool)
}

private struct FfiConverterTypeAccountEvent: FfiConverterRustBuffer {
    typealias SwiftType = AccountEvent

    static func read(from buf: Reader) throws -> AccountEvent {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .commandReceived(
                command: try FfiConverterTypeIncomingDeviceCommand.read(from: buf)
            )

        case 2: return .profileUpdated

        case 3: return .accountAuthStateChanged

        case 4: return .accountDestroyed

        case 5: return .deviceConnected(
                deviceName: try FfiConverterString.read(from: buf)
            )

        case 6: return .deviceDisconnected(
                deviceId: try FfiConverterString.read(from: buf),
                isLocalDevice: try FfiConverterBool.read(from: buf)
            )

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: AccountEvent, into buf: Writer) {
        switch value {
        case let .commandReceived(command):
            buf.writeInt(Int32(1))
            FfiConverterTypeIncomingDeviceCommand.write(command, into: buf)

        case .profileUpdated:
            buf.writeInt(Int32(2))

        case .accountAuthStateChanged:
            buf.writeInt(Int32(3))

        case .accountDestroyed:
            buf.writeInt(Int32(4))

        case let .deviceConnected(deviceName):
            buf.writeInt(Int32(5))
            FfiConverterString.write(deviceName, into: buf)

        case let .deviceDisconnected(deviceId, isLocalDevice):
            buf.writeInt(Int32(6))
            FfiConverterString.write(deviceId, into: buf)
            FfiConverterBool.write(isLocalDevice, into: buf)
        }
    }
}

extension AccountEvent: Equatable, Hashable {}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.
public enum DeviceCapability {
    case sendTab
}

private struct FfiConverterTypeDeviceCapability: FfiConverterRustBuffer {
    typealias SwiftType = DeviceCapability

    static func read(from buf: Reader) throws -> DeviceCapability {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .sendTab

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: DeviceCapability, into buf: Writer) {
        switch value {
        case .sendTab:
            buf.writeInt(Int32(1))
        }
    }
}

extension DeviceCapability: Equatable, Hashable {}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.
public enum DeviceType {
    case desktop
    case mobile
    case tablet
    case vr
    case tv
    case unknown
}

private struct FfiConverterTypeDeviceType: FfiConverterRustBuffer {
    typealias SwiftType = DeviceType

    static func read(from buf: Reader) throws -> DeviceType {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .desktop

        case 2: return .mobile

        case 3: return .tablet

        case 4: return .vr

        case 5: return .tv

        case 6: return .unknown

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: DeviceType, into buf: Writer) {
        switch value {
        case .desktop:
            buf.writeInt(Int32(1))

        case .mobile:
            buf.writeInt(Int32(2))

        case .tablet:
            buf.writeInt(Int32(3))

        case .vr:
            buf.writeInt(Int32(4))

        case .tv:
            buf.writeInt(Int32(5))

        case .unknown:
            buf.writeInt(Int32(6))
        }
    }
}

extension DeviceType: Equatable, Hashable {}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.
public enum IncomingDeviceCommand {
    case tabReceived(sender: Device?, payload: SendTabPayload)
}

private struct FfiConverterTypeIncomingDeviceCommand: FfiConverterRustBuffer {
    typealias SwiftType = IncomingDeviceCommand

    static func read(from buf: Reader) throws -> IncomingDeviceCommand {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .tabReceived(
                sender: try FfiConverterOptionTypeDevice.read(from: buf),
                payload: try FfiConverterTypeSendTabPayload.read(from: buf)
            )

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: IncomingDeviceCommand, into buf: Writer) {
        switch value {
        case let .tabReceived(sender, payload):
            buf.writeInt(Int32(1))
            FfiConverterOptionTypeDevice.write(sender, into: buf)
            FfiConverterTypeSendTabPayload.write(payload, into: buf)
        }
    }
}

extension IncomingDeviceCommand: Equatable, Hashable {}

// Note that we don't yet support `indirect` for enums.
// See https://github.com/mozilla/uniffi-rs/issues/396 for further discussion.
public enum MigrationState {
    case none
    case copySessionToken
    case reuseSessionToken
}

private struct FfiConverterTypeMigrationState: FfiConverterRustBuffer {
    typealias SwiftType = MigrationState

    static func read(from buf: Reader) throws -> MigrationState {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .none

        case 2: return .copySessionToken

        case 3: return .reuseSessionToken

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: MigrationState, into buf: Writer) {
        switch value {
        case .none:
            buf.writeInt(Int32(1))

        case .copySessionToken:
            buf.writeInt(Int32(2))

        case .reuseSessionToken:
            buf.writeInt(Int32(3))
        }
    }
}

extension MigrationState: Equatable, Hashable {}

public enum FxaError {
    // Simple error enums only carry a message
    case Authentication(message: String)

    // Simple error enums only carry a message
    case Network(message: String)

    // Simple error enums only carry a message
    case NoExistingAuthFlow(message: String)

    // Simple error enums only carry a message
    case WrongAuthFlow(message: String)

    // Simple error enums only carry a message
    case Panic(message: String)

    // Simple error enums only carry a message
    case Other(message: String)
}

private struct FfiConverterTypeFxaError: FfiConverterRustBuffer {
    typealias SwiftType = FxaError

    static func read(from buf: Reader) throws -> FxaError {
        let variant: Int32 = try buf.readInt()
        switch variant {
        case 1: return .Authentication(
                message: try FfiConverterString.read(from: buf)
            )

        case 2: return .Network(
                message: try FfiConverterString.read(from: buf)
            )

        case 3: return .NoExistingAuthFlow(
                message: try FfiConverterString.read(from: buf)
            )

        case 4: return .WrongAuthFlow(
                message: try FfiConverterString.read(from: buf)
            )

        case 5: return .Panic(
                message: try FfiConverterString.read(from: buf)
            )

        case 6: return .Other(
                message: try FfiConverterString.read(from: buf)
            )

        default: throw UniffiInternalError.unexpectedEnumCase
        }
    }

    static func write(_ value: FxaError, into buf: Writer) {
        switch value {
        case let .Authentication(message):
            buf.writeInt(Int32(1))
            FfiConverterString.write(message, into: buf)
        case let .Network(message):
            buf.writeInt(Int32(2))
            FfiConverterString.write(message, into: buf)
        case let .NoExistingAuthFlow(message):
            buf.writeInt(Int32(3))
            FfiConverterString.write(message, into: buf)
        case let .WrongAuthFlow(message):
            buf.writeInt(Int32(4))
            FfiConverterString.write(message, into: buf)
        case let .Panic(message):
            buf.writeInt(Int32(5))
            FfiConverterString.write(message, into: buf)
        case let .Other(message):
            buf.writeInt(Int32(6))
            FfiConverterString.write(message, into: buf)
        }
    }
}

extension FxaError: Equatable, Hashable {}

extension FxaError: Error {}

private struct FfiConverterOptionInt64: FfiConverterRustBuffer {
    typealias SwiftType = Int64?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterInt64.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterInt64.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionString: FfiConverterRustBuffer {
    typealias SwiftType = String?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterString.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterString.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeDevice: FfiConverterRustBuffer {
    typealias SwiftType = Device?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeDevice.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeDevice.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeDevicePushSubscription: FfiConverterRustBuffer {
    typealias SwiftType = DevicePushSubscription?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeDevicePushSubscription.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeDevicePushSubscription.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeMetricsParams: FfiConverterRustBuffer {
    typealias SwiftType = MetricsParams?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeMetricsParams.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeMetricsParams.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeScopedKey: FfiConverterRustBuffer {
    typealias SwiftType = ScopedKey?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeScopedKey.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeScopedKey.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionTypeDeviceType: FfiConverterRustBuffer {
    typealias SwiftType = DeviceType?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterTypeDeviceType.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterTypeDeviceType.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterOptionSequenceString: FfiConverterRustBuffer {
    typealias SwiftType = [String]?

    static func write(_ value: SwiftType, into buf: Writer) {
        guard let value = value else {
            buf.writeInt(Int8(0))
            return
        }
        buf.writeInt(Int8(1))
        FfiConverterSequenceString.write(value, into: buf)
    }

    static func read(from buf: Reader) throws -> SwiftType {
        switch try buf.readInt() as Int8 {
        case 0: return nil
        case 1: return try FfiConverterSequenceString.read(from: buf)
        default: throw UniffiInternalError.unexpectedOptionalTag
        }
    }
}

private struct FfiConverterSequenceString: FfiConverterRustBuffer {
    typealias SwiftType = [String]

    static func write(_ value: [String], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterString.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [String] {
        let len: Int32 = try buf.readInt()
        var seq = [String]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterString.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeAttachedClient: FfiConverterRustBuffer {
    typealias SwiftType = [AttachedClient]

    static func write(_ value: [AttachedClient], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeAttachedClient.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [AttachedClient] {
        let len: Int32 = try buf.readInt()
        var seq = [AttachedClient]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeAttachedClient.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeDevice: FfiConverterRustBuffer {
    typealias SwiftType = [Device]

    static func write(_ value: [Device], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeDevice.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [Device] {
        let len: Int32 = try buf.readInt()
        var seq = [Device]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeDevice.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeTabHistoryEntry: FfiConverterRustBuffer {
    typealias SwiftType = [TabHistoryEntry]

    static func write(_ value: [TabHistoryEntry], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeTabHistoryEntry.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [TabHistoryEntry] {
        let len: Int32 = try buf.readInt()
        var seq = [TabHistoryEntry]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeTabHistoryEntry.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeAccountEvent: FfiConverterRustBuffer {
    typealias SwiftType = [AccountEvent]

    static func write(_ value: [AccountEvent], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeAccountEvent.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [AccountEvent] {
        let len: Int32 = try buf.readInt()
        var seq = [AccountEvent]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeAccountEvent.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeDeviceCapability: FfiConverterRustBuffer {
    typealias SwiftType = [DeviceCapability]

    static func write(_ value: [DeviceCapability], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeDeviceCapability.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [DeviceCapability] {
        let len: Int32 = try buf.readInt()
        var seq = [DeviceCapability]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeDeviceCapability.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterSequenceTypeIncomingDeviceCommand: FfiConverterRustBuffer {
    typealias SwiftType = [IncomingDeviceCommand]

    static func write(_ value: [IncomingDeviceCommand], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for item in value {
            FfiConverterTypeIncomingDeviceCommand.write(item, into: buf)
        }
    }

    static func read(from buf: Reader) throws -> [IncomingDeviceCommand] {
        let len: Int32 = try buf.readInt()
        var seq = [IncomingDeviceCommand]()
        seq.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            seq.append(try FfiConverterTypeIncomingDeviceCommand.read(from: buf))
        }
        return seq
    }
}

private struct FfiConverterDictionaryStringString: FfiConverterRustBuffer {
    fileprivate static func write(_ value: [String: String], into buf: Writer) {
        let len = Int32(value.count)
        buf.writeInt(len)
        for (key, value) in value {
            FfiConverterString.write(key, into: buf)
            FfiConverterString.write(value, into: buf)
        }
    }

    fileprivate static func read(from buf: Reader) throws -> [String: String] {
        let len: Int32 = try buf.readInt()
        var dict = [String: String]()
        dict.reserveCapacity(Int(len))
        for _ in 0 ..< len {
            let key = try FfiConverterString.read(from: buf)
            let value = try FfiConverterString.read(from: buf)
            dict[key] = value
        }
        return dict
    }
}

/**
 * Top level initializers and tear down methods.
 *
 * This is generated by uniffi.
 */
public enum FxaClientLifecycle {
    /**
     * Initialize the FFI and Rust library. This should be only called once per application.
     */
    func initialize() {}
}
